//
//  PirateGame.m
//  Hock
//
//  Created by orta on 12/11/2008.
//  Copyright 2008 ortatherox.com / Brainjice LLC. All rights reserved.
//  and http://thwart-ipa-cracks.blogspot.com/
//
//  Howto:
//    Add this and the header file to your Project
//    use the following code to laod this scene instead
//    in  applicationDidFinishLaunching:(UIApplication*)application

// //anti piracy
//  NSBundle *bundle = [NSBundle mainBundle];
//  NSDictionary *info = [bundle infoDictionary];
//  if ([info objectForKey: @"SignedIdentity"] != nil){
//    [scene removeAll];
//    [scene add:[PirateGame node]];
//  }
//  [[Director sharedDirector] runScene: scene];
//}

//     make sure to #import "PirateGame.h"


#import "PirateGame.h"


extern cpSpace *space;
extern cpBody * staticBody;


void drawCircleShape(cpShape *shape) {
	cpBody *body = shape->body;
	cpCircleShape *circle = (cpCircleShape *)shape;
	cpVect c = cpvadd(body->p, cpvrotate(circle->c, body->rot));
	drawCircle(c.x, c.y, circle->r, body->a, 25);
  // !important this number changes the quality of circles
}

void drawSegmentShape(cpShape *shape) {
	cpBody *body = shape->body;
	cpSegmentShape *seg = (cpSegmentShape *)shape;
	cpVect a = cpvadd(body->p, cpvrotate(seg->a, body->rot));
	cpVect b = cpvadd(body->p, cpvrotate(seg->b, body->rot));
	drawLine( a.x, a.y, b.x, b.y );
}

void drawPolyShape(cpShape *shape) {
	cpBody *body = shape->body;
	cpPolyShape *poly = (cpPolyShape *)shape;
	
	int num = poly->numVerts;
	cpVect *verts = poly->verts;
	
	float *vertices = malloc( sizeof(float)*2*poly->numVerts);
	if(!vertices)
		return;
	
	for(int i=0; i<num; i++){
		cpVect v = cpvadd(body->p, cpvrotate(verts[i], body->rot));
		vertices[i*2] = v.x;
		vertices[i*2+1] = v.y;
	}
	drawPoly( vertices, poly->numVerts );
	free(vertices);
}

void drawObject(void *ptr, void *unused) {
	cpShape *shape = (cpShape *)ptr;  
  glColor4f(1.0, 1.0, 1.0, 0.7);
  
  //if its the player
  if(shape->group == 55){
    glColor4f(1.0, 1.0, 1.0, 1.0);
  }
  
	switch(shape->klass->type){
		case CP_CIRCLE_SHAPE:
			drawCircleShape(shape);
			break;
		case CP_SEGMENT_SHAPE:
			drawSegmentShape(shape);
			break;
		case CP_POLY_SHAPE:
			drawPolyShape(shape);
			break;
		default:
			printf("Bad enumeration in drawObject().\n");
	}
}

cpBody* makeCircle(int radius){
  int num = 4;
  cpVect verts[] = {
    cpv(-radius, -radius),
    cpv(-radius, radius),
    cpv( radius, radius),
    cpv( radius, -radius),
  };
  // all physics stuff needs a body
  cpBody *body = cpBodyNew(1.0, cpMomentForPoly(1.0, num, verts, cpvzero));
  cpSpaceAddBody(space, body);
  // and a shape to represent its collision box
  cpShape* shape = cpCircleShapeNew(body, radius, cpvzero);
  shape->e = 0.1; shape->u = 0.5;
  cpSpaceAddShape(space, shape);
  return body;
}

void makeStaticBox(float x, float y, float width, float height){
  cpShape * shape;
  shape = cpSegmentShapeNew(staticBody, cpv(x,y), cpv(x+width, y), 0.0f);
  shape->e = 1.0; shape->u = 1.0;
  cpSpaceAddStaticShape(space, shape);
  
  shape = cpSegmentShapeNew(staticBody, cpv(x+width, y), cpv(x+width, y+height ), 0.0f);
  shape->e = 1.0; shape->u = 1.0;
  cpSpaceAddStaticShape(space, shape);
  
  shape = cpSegmentShapeNew(staticBody, cpv(x+width, y+height), cpv(x, y+height ), 0.0f);
  shape->e = 1.0; shape->u = 1.0;
  cpSpaceAddStaticShape(space, shape);
  
  shape = cpSegmentShapeNew(staticBody, cpv(x, y+height ), cpv(x, y), 0.0f);
  shape->e = 1.0; shape->u = 1.0;
  cpSpaceAddStaticShape(space, shape);
}


void make_scenery_line(cpFloat x, cpFloat y, cpFloat x2, cpFloat y2){
  cpShape *shape;
  shape = cpSegmentShapeNew(staticBody, cpv(x,y), cpv(x2, y2), 0.0f);
	shape->e = 0.7; shape->u = 2.0;
	cpSpaceAddStaticShape(space, shape);
}

void createSkull(){
  //top
  make_scenery_line(90, 400, 230, 400);
  //right side
  make_scenery_line(230, 400, 260, 360);
  make_scenery_line(260, 360, 260, 310);
  make_scenery_line(260, 310, 240, 250);
  make_scenery_line(240, 250, 240, 190);
  //bottom
  make_scenery_line(240, 190, 80, 190);
  make_scenery_line(240, 220, 80, 220);
  //left
  make_scenery_line(60, 360, 90, 400);
  make_scenery_line(60, 360, 60, 310);
  make_scenery_line(60, 310, 80, 250);
  make_scenery_line(80, 250, 80, 190);

  //left eye
  make_scenery_line(90, 350, 145, 355);
  make_scenery_line(145, 355, 140, 315);
  make_scenery_line(140, 315, 90, 350);
  //right eye
  make_scenery_line(320-90, 350, 320-145, 355);
  make_scenery_line(320-145, 355, 320-140, 315);
  make_scenery_line(320-140, 315, 320-90, 350);
  
  //left nose
  make_scenery_line(140, 280, 145, 290);
  make_scenery_line(145, 290, 145, 280);
  make_scenery_line(145, 280, 140, 280);

  //right
  make_scenery_line(320-140, 280, 320-145, 290);
  make_scenery_line(320-145, 290, 320-145, 280);
  make_scenery_line(320-145, 280, 320-140, 280);
  

}

void  createPlayer () {  
  cpShape * shape;
	int num = 4;
  int kColl_Player = 55;
  cpFloat chestMass = 15;
	cpVect verts[] = {
		cpv(-8,-12),
		cpv(-8, 12),
		cpv( 8, 12),
		cpv( 8,-12),
	};
	
	cpBody * playerChest = cpBodyNew(10.0, cpMomentForPoly(chestMass, num, verts, cpv(0,0)));
	cpSpaceAddBody(space, playerChest);
	shape = cpPolyShapeNew(playerChest, num, verts, cpv(0,0));
	shape->e = 0.0; shape->u = 1.0;
  shape->group = kColl_Player;
  playerChest ->p = cpv(160,240);
	cpSpaceAddShape(space, shape);
	
	cpFloat radius = 10;
	cpFloat head_mass = 0.01;
  cpVect offset = cpv(0, 12);
	cpBody *playerHead = cpBodyNew(head_mass, cpMomentForCircle(head_mass, 0.0, radius, cpvzero));
	playerHead->p = cpvadd(playerChest->p, offset);
	playerHead->v = playerChest->v;
	cpSpaceAddBody(space, playerHead);
	shape = cpCircleShapeNew(playerHead, radius, cpvzero);
	shape->e = 0.0; shape->u = 2.5;
  shape->collision_type = kColl_Player;
  shape->group = kColl_Player;
	cpSpaceAddShape(space, shape);
  // apply a small upwards force to keep the head up,
  // this may need adjusting when/if gravity is changed.
  
  // plus this adds an awesome drunkard swagger!
	cpBodyApplyForce(playerHead, cpv(0, 10), cpvzero);
  cpJoint *joint;
	joint = cpPinJointNew(playerChest, playerHead, cpv(0, 10), cpv(0, -5));
	cpSpaceAddJoint(space, joint);
  
  cpVect armverts[] = {
		cpv(-6,-2),
		cpv(-6, 2),
		cpv( 6, 2),
		cpv( 6,-2),
	};
  
  cpBody * playerArm1 = cpBodyNew(0.1, cpMomentForPoly(0.1, num, armverts, cpv(0,0)));
  cpSpaceAddBody(space, playerArm1);
	shape = cpPolyShapeNew(playerArm1, num, armverts, cpv(0,0));
  shape->collision_type = kColl_Player;
	shape->e = 0.0; shape->u = 1.0;
  shape->group = kColl_Player;
  playerArm1 ->p = cpv(160,240);
	cpSpaceAddShape(space, shape);
  joint = cpPinJointNew(playerChest, playerArm1, cpv(5, 0), cpv(5,0));
	cpSpaceAddJoint(space, joint);
  
  cpBody * playerArm2= cpBodyNew(0.1, cpMomentForPoly(0.1, num, armverts, cpv(0,0)));
  cpSpaceAddBody(space, playerArm2);
	shape = cpPolyShapeNew(playerArm2, num, armverts, cpv(0,0));
  shape->collision_type = kColl_Player;
	shape->e = 0.0; shape->u = 1.0;
  shape->group = kColl_Player;
  
  playerArm2 ->p = cpv(160,240);
	cpSpaceAddShape(space, shape);
  joint = cpPinJointNew(playerChest, playerArm2, cpv(-5, 3), cpv(-5, 3));
	cpSpaceAddJoint(space, joint);
}


@implementation PirateGame 
-(id) init {
  
  [super init];
  [self initChipmunk];
  isTouchEnabled = YES;
  isAccelerometerEnabled = YES;
  [[UIAccelerometer sharedAccelerometer] setUpdateInterval:(1.0 / 60)];
  
  //seed the random generator
  srand([[NSDate date] timeIntervalSince1970]);
  
  // make a bunch of circles
  for (int i = 0; i < (rand() % 10) + 20; i++) {
    cpBody* circle = makeCircle((rand() % 20) + 5);
    circle->p = cpv( (rand() % 240) + 30,  (rand() % 120) + 30);
  }
  
  glEnable(GL_LINE_SMOOTH);
  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  glHint(GL_LINE_SMOOTH_HINT, GL_DONT_CARE);
  
  return self;
}  

- (void) initChipmunk{
  // start chipumnk
  // create the space for the bodies
  // and set the hash to a rough estimate of how many shapes there could be
  // set gravity, make the physics run loop
  // make a bounding box the size of the screen
  
  cpInitChipmunk();
  space = cpSpaceNew();
	cpSpaceResizeStaticHash(space, 4, 20);
  cpSpaceResizeActiveHash(space, 50.0, 500);
  
	space->gravity = cpv(0, -200);
  staticBody = cpBodyNew(INFINITY, INFINITY);  
  [self schedule: @selector(step:)];
  
  CGRect window = [[Director sharedDirector] winSize];
  int margin = 4;
  int dmargin = margin*2;
  makeStaticBox(margin, margin, window.size.width - dmargin, window.size.height - dmargin);
  createPlayer();
  createSkull();

}

- (void) draw{  
  glColor4f(1.0, 1.0, 1.0, 1.0);
  cpSpaceHashEach(space->activeShapes, &drawObject, NULL);
  glColor4f(1.0, 1.0, 1.0, 0.7);
  cpSpaceHashEach(space->staticShapes, &drawObject, NULL);  
}

- (void)touchesMoved:(NSSet*)touches withEvent:(UIEvent*)event{  
  UITouch *myTouch =  [touches anyObject];
  CGPoint location = [myTouch locationInView: [myTouch view]];
  location = [[Director sharedDirector] convertCoordinate: location];
  cpMouseMove(mouse, cpv(location.x, location.y));
  if(mouse->grabbedBody == nil){
    cpMouseGrab(mouse, 0);
  }
}

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {
  UITouch *myTouch =  [touches anyObject];
  CGPoint location = [myTouch locationInView: [myTouch view]];
  location = [[Director sharedDirector] convertCoordinate: location];
  mouse = cpMouseNew(space);
  cpMouseMove(mouse, cpv(location.x, location.y));
  cpMouseGrab(mouse, 0);
}

- (void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event {
  [self touchesCancelled:touches withEvent:event];
}
- (void)touchesCancelled:(NSSet *)touches withEvent:(UIEvent *)event {
  cpMouseDestroy(mouse);
}


-(void) step: (ccTime) delta {
	int steps = 2;
	cpFloat dt = delta/(cpFloat)steps;
	for(int i=0; i<steps; i++){
		cpSpaceStep(space, dt);
	}
} 

- (void)accelerometer:(UIAccelerometer*)accelerometer didAccelerate:(UIAcceleration*)acceleration{	
  static float prevX=0, prevY=0;	
#define kFilterFactor 0.05
  
  float accelX = acceleration.x * kFilterFactor + (1- kFilterFactor)*prevX;
  float accelY = acceleration.y * kFilterFactor + (1- kFilterFactor)*prevY;
  
  prevX = accelX;
  prevY = accelY;
  
  cpVect v = cpv( accelX, accelY);
  space->gravity = cpvmult(v, 200);  
}
@end
